Index: source/ariba/communication/modules/transport/protlib/address.cpp
===================================================================
--- source/ariba/communication/modules/transport/protlib/address.cpp	(revision 2378)
+++ source/ariba/communication/modules/transport/protlib/address.cpp	(revision 4890)
@@ -6,5 +6,5 @@
 /// $HeadURL: https://svn.ipv6.tm.uka.de/nsis/protlib/trunk/src/address.cpp $
 // ===========================================================
-//                      
+//
 // Copyright (C) 2005-2007, all rights reserved by
 // - Institute of Telematics, Universitaet Karlsruhe (TH)
@@ -12,5 +12,5 @@
 // More information and contact:
 // https://projekte.tm.uka.de/trac/NSIS
-//                      
+//
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -54,8 +54,8 @@
 
 /** Set subtype. */
-address::address(subtype_t st) 
-	: subtype(st) 
-{ 
-  //Log(DEBUG_LOG,LOG_NORMAL,"address","address constructor called for " << (void *) this); 
+address::address(subtype_t st)
+	: subtype(st)
+{
+  //Log(DEBUG_LOG,LOG_NORMAL,"address","address constructor called for " << (void *) this);
 }
 
@@ -83,5 +83,5 @@
 	catch_bad_alloc(ha =  new hostaddress(*this));
 	return ha;
-} // end copy 
+} // end copy
 
 bool hostaddress::operator==(const address& ie) const {
@@ -102,7 +102,7 @@
 
 /** Initialize hostaddress from string if possible. */
-hostaddress::hostaddress(const char *str, bool *res) 
+hostaddress::hostaddress(const char *str, bool *res)
 	: address(IPv6HostAddress),
-	  ipv4flag(false), 
+	  ipv4flag(false),
 	  outstring(NULL)
 {
@@ -118,5 +118,5 @@
  * @return true on success.
  */
-bool 
+bool
 hostaddress::set_ipv4(const char *str) {
 	struct in_addr in;
@@ -127,10 +127,10 @@
 } // end set_ipv4
 
-/** Set IPv4 address from struct in_addr. 
- * This changes object type to IPv4. 
+/** Set IPv4 address from struct in_addr.
+ * This changes object type to IPv4.
  */
 void hostaddress::set_ip(const struct in_addr &in) {
 	clear_ip();
-	ipv4addr = in;	
+	ipv4addr = in;
 	// set subtype to IPv4
 	set_subtype(true);
@@ -148,13 +148,13 @@
 		return true;
 	} else return false;
-} // end set_ipv6	
-
-/** Set IPv6 address from struct in6_addr. 
- * This changes object type to IPv6. 
- */
-void 
+} // end set_ipv6
+
+/** Set IPv6 address from struct in6_addr.
+ * This changes object type to IPv6.
+ */
+void
 hostaddress::set_ip(const struct in6_addr &in) {
 	clear_ip();
-	ipv6addr = in;	
+	ipv6addr = in;
 	// set subtype to IPv6
 	set_subtype(false);
@@ -185,19 +185,19 @@
  * hostaddress object and should be copied if used for a longer time.
  */
-const char* hostaddress::get_ip_str() const 
+const char* hostaddress::get_ip_str() const
 {
   // If outstring exists then it is valid.
-  if (outstring) 
+  if (outstring)
     return outstring;
   else
-    outstring= (ipv4flag ? new(nothrow) char[INET_ADDRSTRLEN] : 
+    outstring= (ipv4flag ? new(nothrow) char[INET_ADDRSTRLEN] :
 		           new(nothrow) char[INET6_ADDRSTRLEN]);
 
-  if (hostaddress::get_ip_str(outstring)) 
+  if (hostaddress::get_ip_str(outstring))
     return outstring;
-  else 
+  else
   {
     // error
-    if (outstring) 
+    if (outstring)
       delete[] outstring;
 
@@ -209,9 +209,9 @@
  * @param str string buffer
  */
-const char* hostaddress::get_ip_str(char *str) const 
+const char* hostaddress::get_ip_str(char *str) const
 {
   if (!str) return NULL;
   memset(str,0, ipv4flag ? INET_ADDRSTRLEN : INET6_ADDRSTRLEN);
-  return ipv4flag ? inet_ntop(AF_INET,(void*)&ipv4addr,str,INET_ADDRSTRLEN) 
+  return ipv4flag ? inet_ntop(AF_INET,(void*)&ipv4addr,str,INET_ADDRSTRLEN)
                   : inet_ntop(AF_INET6,(void*)&ipv6addr,str,INET6_ADDRSTRLEN);
 } // end get_ip_str(char*)
@@ -247,10 +247,10 @@
 /// returns false if address is not allowed to be used
 /// as source address: loopback, multicast, broadcast, unspecified
-bool 
+bool
 hostaddress::is_bogus_source() const
 {
   if (ipv4flag)
   { // IPv4
-    if ( IN_MULTICAST(ipv4addr.s_addr) || 
+    if ( IN_MULTICAST(ipv4addr.s_addr) ||
 	 ipv4addr.s_addr == INADDR_LOOPBACK  ||
          ipv4addr.s_addr == INADDR_ANY ||
@@ -323,8 +323,8 @@
 
 /** Set subtype and IPv4 flag. This does NOT clear the outstring buffer.
- * Use clear_ip(). 
+ * Use clear_ip().
  */
 void hostaddress::set_subtype(bool ipv4) {
-	ipv4flag = ipv4; 
+	ipv4flag = ipv4;
 	subtype = ipv4flag ? IPv4HostAddress : IPv6HostAddress;
 } // end set_subtype
@@ -422,5 +422,5 @@
 	catch_bad_alloc(aa = new appladdress(*this));
 	return aa;
-} // end copy 
+} // end copy
 
 bool appladdress::operator==(const address& ie) const {
@@ -454,5 +454,5 @@
 	catch_bad_alloc(na = new netaddress(*this));
 	return na;
-} // end copy 
+} // end copy
 
 bool netaddress::operator==(const address& ie) const {
@@ -485,11 +485,11 @@
 
 /** Set subtype and IPv4 flag. This does NOT clear the outstring buffer.
- * Use clear_ip(). 
+ * Use clear_ip().
  * In addition the prefix length is checked and set to reasonable values.
  */
 void netaddress::set_subtype(bool ipv4) {
-	ipv4flag = ipv4; 
+	ipv4flag = ipv4;
 	if (ipv4) {
-		subtype = IPv4NetAddress; 
+		subtype = IPv4NetAddress;
 		if (prefix_length>32) prefix_length = 32;
 	} else {
@@ -502,5 +502,5 @@
 
 /** Constructor sets address type and clears prefix length. */
-netaddress::netaddress() : 
+netaddress::netaddress() :
   hostaddress(),
   prefix_length(0)
@@ -514,5 +514,5 @@
 } // end copy constructor
 
-/** Initialize with the given host address and prefix length. 
+/** Initialize with the given host address and prefix length.
  * Prefix length is optional and set to 0 if missing.
  */
@@ -530,5 +530,5 @@
 	long int len = 0;
 	uint32 iplen;
-	char* i = NULL;
+	const char* i = NULL;
 	char* errptr = NULL;
 	char ipstr[INET6_ADDRSTRLEN] = {0};
@@ -785,5 +785,5 @@
 	catch_bad_alloc(ha =  new udsaddress(*this));
 	return ha;
-} // end copy 
+} // end copy
 
 bool udsaddress::operator==(const address& ie) const {
@@ -876,5 +876,5 @@
 		}
 		props->insert(pair<AddrProperty *, bool>(p, propagate));
-		
+
 	} else {
 		props = new propmap_t();
@@ -1525,5 +1525,5 @@
 	if (head->right->index > head->index)
 		collect(head->right, p, list);
-	
+
 }
 